<!--********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->

<style>
  :host ::ng-deep .p-panel-header {
    padding: 0.5rem 1.25rem;
    line-height: 1;
  }
</style>

<p-panel toggler="header">
  <ng-template pTemplate="header">
    <span class="font-bold">{{ "search.mdm-search.lbl-search-filter" | translate }}</span>
    &nbsp;&nbsp;
    <p-dropdown
      [options]="filterModel"
      [(ngModel)]="selectedFilter"
      (onChange)="onFilterChange($event)"
      class="inline w33"
      [style]="{ width: '100%', 'min-width': '12em' }"
      placeholder="{{ 'search.filter.no-filter-selected' | translate }}"
    ></p-dropdown>
    <p-button
      icon="fa fa-file-o"
      styleClass="ml-1"
      (onClick)="newSearchFieldsEditor($event)"
      [title]="'search.mdm-search.tooltip-create-new-search-filter' | translate"
      [disabled]="!isAdvancedSearchActive"
    ></p-button>
    <p-button
      icon="pi pi-save"
      styleClass="ml-1"
      (onClick)="showSaveModal($event)"
      [title]="'search.mdm-search.tooltip-save-search-filter' | translate"
      [disabled]="!isAdvancedSearchActive"
    ></p-button>
    <p-button
      icon="pi pi-trash"
      styleClass="ml-1 mr-1"
      (onClick)="deleteFilter($event)"
      [disabled]="!selectedFilter"
      [title]="'search.mdm-search.tooltip-delete-search-filter' | translate"
    ></p-button>

    <mdm-sharelink [customStateCallback]="getStateForTakeOver.bind(this)"></mdm-sharelink>
  </ng-template>
  <ng-template pTemplate="icons">
    <p-button (onClick)="onSearch()">{{ "search.mdm-search.btn-search" | translate }}</p-button>
  </ng-template>
  <div class="formgroup-inline">
    <div class="field">
      <label class="mb-2" for="search-source" [title]="'search.mdm-search.lbl-source' | translate">{{
        "search.mdm-search.lbl-source" | translate
      }}</label>
      <p-multiSelect
        [options]="dropdownModel"
        maxSelectedLabels="2"
        [(ngModel)]="selectedEnvs"
        (onChange)="selectedEnvironmentsChanged()"
        title="{{ 'search.mdm-search.tooltip-select-sources' | translate }}"
        styleClass="w-full"
      ></p-multiSelect>
    </div>
    <div class="field">
      <label class="mb-2" for="search-resulttype" [title]="'search.mdm-search.lbl-result-type' | translate">{{
        "search.mdm-search.lbl-result-type" | translate
      }}</label>
      <p-dropdown
        *ngIf="selectedDefinition"
        [options]="definitions"
        [(ngModel)]="selectedDefinition"
        (onChange)="onResultTypeChanged($event)"
        styleClass="w-full"
      >
        <ng-template let-option pTemplate="selectedItem">
          <div style="display: flex; align-items: center">
            <img [src]="option?.type | typeIcon" style="padding-right: 0.5rem" />
            <span>{{ option?.type | mdmTranslate : (environments?.length > 0 ? environments[0].sourceName : undefined) | async }}</span>
          </div>
        </ng-template>
        <ng-template let-option pTemplate="item">
          <div style="display: flex; align-items: center">
            <img [src]="option?.type | typeIcon" style="padding-right: 0.5rem" />
            <span>{{ option?.type | mdmTranslate : (environments?.length > 0 ? environments[0].sourceName : undefined) | async }}</span>
          </div>
        </ng-template>
      </p-dropdown>
    </div>
    <div class="field flex-grow-1 mr-0">
      <label class="mb-2" for="search-text-id" [title]="'search.mdm-search.lbl-full-text-search' | translate">{{
        "search.mdm-search.lbl-full-text-search" | translate
      }}</label>
      <input
        *ngIf="currentFilter"
        id="search-text-id"
        type="text"
        pInputText
        class="w-full"
        name="searchText"
        [placeholder]="'search.mdm-search.enter-search-text' | translate"
        [(ngModel)]="currentFilter.fulltextQuery"
        (keyup.enter)="onSearch()"
        aria-describedby="basic-addon1"
        [title]="'search.mdm-search.tooltip-search-text' | translate"
      />
    </div>
  </div>

  <p-panel toggler="header" [toggleable]="true" [(collapsed)]="isAdvancedSearchClosed" [style.line-height]="1">
    <ng-template pTemplate="header">
      <input
        type="checkbox"
        [(ngModel)]="isAdvancedSearchActive"
        (click)="onCheckBoxClick($event)"
        [title]="getAdvancedSearchCbxTitle() | translate"
      />
      &nbsp;{{ "search.mdm-search.lbl-advanced-search" | translate }}
      &nbsp;&nbsp;
      <p-button
        *ngIf="currentFilter"
        icon="pi pi-pencil"
        [title]="'search.mdm-search.tooltip-edit-search-filter' | translate"
        (onClick)="showSearchFieldsEditor($event, currentFilter.conditions)"
        [disabled]="!isAdvancedSearchActive"
      ></p-button>
    </ng-template>
    <ng-template pTemplate="icons">
      <p-button
        icon="fa fa-json"
        styleClass="ml-1"
        (onClick)="openJsonSearch(); $event.stopPropagation()"
        *ngIf="hasJsonButton"
        [title]="'search.mdm-search.tooltip-search-as-json' | translate"
        >Json</p-button
      >
      <p-toggleButton
        styleClass="ml-1"
        [(ngModel)]="isSearchLinkedToNavigator"
        onIcon="fa fa-link"
        offIcon="fa fa-unlink"
        (onChange)="onToggleSearchLinkedToNavigator($event)"
        [title]="
          (isSearchLinkedToNavigator
            ? 'search.mdm-search.tooltip-unlink-search-attributes-from-navigator'
            : 'search.mdm-search.tooltip-link-search-attributes-to-navigator'
          ) | translate
        "
      >
      </p-toggleButton>
      <p-button
        icon="fa fa-eraser"
        styleClass="ml-1"
        (onClick)="resetConditions($event)"
        [title]="'search.mdm-search.tooltip-reset-search-conditions' | translate"
        [disabled]="!isAdvancedSearchActive"
      ></p-button>
      <p-button
        icon="pi pi-times-circle"
        styleClass="ml-1"
        (onClick)="removeAllSearchAttributes($event)"
        [title]="'search.mdm-search.tooltip-remove-search-attributes' | translate"
        [disabled]="!isAdvancedSearchActive"
      ></p-button>
    </ng-template>
    <ng-template pTemplate="content">
      <div *ngIf="layout.getSourceNames().length === 0" style="text-align: center; margin-bottom: 5px">
        {{ "search.mdm-search.no-search-attributes-selected" | translate }}
      </div>
      <div *ngFor="let env of layout.getSourceNames()">
        <div *ngIf="layout.getConditions(env).length > 0">
          <div
            style="font-weight: bold"
            *ngIf="mapSourceNameToName(env) === 'Global'"
            [title]="'search.mdm-search.tooltip-global-search-attributes' | translate"
          >
            {{ "search.mdm-search.global-search-attributes" | translate }}
          </div>
          <div
            style="font-weight: bold"
            *ngIf="mapSourceNameToName(env) !== 'Global'"
            [title]="'search.mdm-search.tooltip-local-search-attributes' | translate"
          >
            {{ "search.mdm-search.search-attributes-from" | translate }}
            {{ mapSourceNameToName(env) }}
          </div>

          <mdm-search-condition
            class="condition"
            *ngFor="let condition of layout.getConditions(env)"
            [env]="env"
            [condition]="condition"
            [disabled]="!isAdvancedSearchActive"
            [selectedEnvs]="selectedEnvironments"
            [defaultSourceName]="env === 'Global' ? environments[0].sourceName : env"
            (remove$)="removeCondition($event)"
            (autoCompleteEdit)="onEditAutoCompleteSuggestion($event)"
          ></mdm-search-condition>
        </div>
      </div>
    </ng-template>
  </p-panel>
</p-panel>

<p-panel toggler="header" [toggleable]="true" [(collapsed)]="isSearchResultsClosed" [style.line-height]="1">
  <ng-template pTemplate="header">
    <span class="font-bold">{{ "search.mdm-search.results" | translate }}</span>
    &nbsp;&nbsp;
    <mdm-view stateKey="search-result-view" (click)="onViewClick($event)" (view)="onViewChanged($event)"></mdm-view>
  </ng-template>
  <ng-template pTemplate="icons">
    <span class="badge badge-pill badge-primary ml-1" *ngFor="let item of results?.totalRecords | keyvalue">
      {{ item.key }}: {{ item.value }}
    </span>
    <p-button
      icon="fa fa-line-chart"
      styleClass="ml-1"
      (onClick)="quickPlotMetadataTrends($event)"
      [title]="'basket.mdm-basket.quick-plot' | translate"
    ></p-button>
    <p-button
      icon="fa fa-eraser"
      styleClass="ml-1"
      (onClick)="clearResultlist($event)"
      [title]="'search.mdm-search.tooltip-clear-search-results' | translate"
    ></p-button>
    <p-button
      icon="fa fa-shopping-cart"
      styleClass="ml-1"
      (onClick)="selected2Basket($event)"
      [title]="'search.mdm-search.tooltip-add-selection-to-shopping-basket' | translate"
    ></p-button>
  </ng-template>
  <ng-template pTemplate="content">
    <mdm-tableview
      [results]="results"
      [view]="selectedView"
      isShopable="true"
      [menuItems]="contextMenuItems"
      [selectedEnvs]="selectedEnvironments"
      [searchAttributes]="allSearchAttributesForCurrentResultType"
      [environments]="environments"
      [loading]="loading"
    >
    </mdm-tableview>
  </ng-template>
</p-panel>

<p-dialog
  header="{{ 'basket.mdm-basket.quick-plot' | translate }}"
  [(visible)]="lgQuickPlotModal"
  [modal]="true"
  [style]="{ width: '75vw' }"
>
  <mdm-quick-plot [items]="this.selectedItems"></mdm-quick-plot>
</p-dialog>

<p-dialog
  [modal]="true"
  [style]="{ width: '50vw' }"
  header="{{ 'search.mdm-search.title-save-search-filter-as' | translate }}"
  [(visible)]="lgSaveModal"
>
  <div class="flex flex-column gap-2">
    <p-table
      *ngIf="getFiltersForSave().length > 0"
      [value]="getFiltersForSave()"
      resizableColumns="false"
      [reorderableColumns]="false"
      [rows]="10"
      [paginator]="true"
      [pageLinks]="3"
      selectionMode="single"
      [rowsPerPageOptions]="[10, 20, 50]"
      [(selection)]="selectedFilterToSave"
      (onRowUnselect)="onRowUnselect()"
      (onRowSelect)="onRowSelect($event)"
      styleClass="table-hover p-datatable-gridlines"
      responsiveLayout="scroll"
      paginatorDropdownAppendTo="body"
      [alwaysShowPaginator]="false"
    >
      <ng-template pTemplate="header">
        <tr>
          <th>Filters</th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-filter>
        <tr [pSelectableRow]="filter">
          <td>
            {{ filter.name }}
          </td>
        </tr>
      </ng-template>
    </p-table>
    <div class="flex align-items-center justify-content-between gap-2">
      <input
        type="text"
        class="form-control"
        placeholder="{{ 'search.mdm-search.search-filter-name' | translate }}"
        [(value)]="filterName"
        (input)="filterName = $event.target.value"
        (keyup.enter)="saveFilter($event)"
      />
      <p-button
        icon="pi pi-save"
        (onClick)="saveFilter($event)"
        [disabled]="!filterName"
        [title]="getSaveFilterBtnTitle() | translate"
        [label]="'search.mdm-search.btn-save' | translate"
      ></p-button>
    </div>
  </div>
</p-dialog>

<p-dialog
  [header]="'search.mdm-search.edit-suggestion-value' | translate"
  [(visible)]="canEditAutoCompleteSuggestion"
  showEffect="fade"
  [modal]="true"
  (onHide)="hideDialogAutoCompleteSuggestion()"
  (onShow)="setInputFocus('ac_suggestion_value')"
  [contentStyle]="{ width: '36em', 'min-height': '8em' }"
>
  <div class="ui-g ui-fluid" *ngIf="canEditAutoCompleteSuggestion">
    <div class="ui-g-4">
      <label for="ac_suggestion_value" class="col-form-label">{{ "search.mdm-search.suggestion-value" | translate }}</label>
    </div>
    <div class="ui-g-8">
      <input
        id="ac_suggestion_value"
        *ngIf="canEditAutoCompleteSuggestion"
        pInputText
        [(ngModel)]="editingAutoCompleteSuggestion.suggestionValue"
        (keyup.enter)="saveAutoCompleteSuggestion()"
        class="form-control"
      />
    </div>
  </div>
  <p-footer>
    <p-button icon="pi pi-check" (onClick)="saveAutoCompleteSuggestion()" [label]="'search.mdm-search.btn-save' | translate"></p-button>
    <p-button
      icon="pi pi-times-circle"
      (onClick)="cancelDialogAutoCompleteSuggestion()"
      [label]="'search.mdm-search.btn-cancel' | translate"
    ></p-button>
  </p-footer>
</p-dialog>

<p-dialog
  [header]="'search.mdm-search.search-filter-delete-title' | translate"
  [(visible)]="dialogSearchFilterDelete"
  [modal]="true"
  (onHide)="cancelRemoveSearchFilter()"
  (keyup.enter)="cancelRemoveSearchFilter()"
>
  <div *ngIf="tmpFilterDelete">
    {{ "search.mdm-search.search-filter-delete-text" | translate }}&nbsp; <br /><strong *ngIf="tmpFilterDelete">{{
      tmpFilterDelete.name
    }}</strong>
  </div>
  <p-footer>
    <p-button icon="pi pi-times" (onClick)="cancelRemoveSearchFilter()" [label]="'search.mdm-search.btn-cancel' | translate"></p-button>
    <p-button
      icon="pi pi-check"
      (onClick)="confirmedRemoveSearchFilter()"
      [label]="'search.mdm-search.search-filter-btn-delete' | translate"
    ></p-button>
  </p-footer>
</p-dialog>

<p-dialog
  [header]="'search.mdm-search.search-filter-changed-title' | translate"
  [(visible)]="dialogSearchFilterChanged"
  [modal]="true"
  (onHide)="exitSearchFilterChanged()"
>
  <div class="ui-g ui-fluid" *ngIf="tmpFilterChanged">
    <div class="ui-g-12">
      <div class="text">
        <span>
          {{ "search.mdm-search.search-filter-changed-text" | translate }}&nbsp; <br /><strong *ngIf="tmpFilterChanged">{{
            tmpFilterChanged.name
          }}</strong>
        </span>
      </div>
    </div>
  </div>
  <p-footer>
    <p-button icon="pi pi-check" (onClick)="saveChangedFilter()" [label]="'search.mdm-search.btn-yes' | translate"></p-button>
    <p-button icon="pi pi-backward" (onClick)="reloadFilter()" [label]="'search.mdm-search.btn-no' | translate"></p-button>
    <p-button
      icon="pi pi-times"
      (onClick)="dialogSearchFilterChanged = false"
      [label]="'search.mdm-search.btn-cancel' | translate"
    ></p-button>
  </p-footer>
</p-dialog>

<mdm-edit-search-fields
  [searchAttributes]="allSearchAttributesForCurrentResultType"
  [environments]="selectedEnvironments"
  [filters]="getFiltersForNew()"
></mdm-edit-search-fields>
<mdm-overwrite-dialog></mdm-overwrite-dialog>

<p-dialog modal="true" [header]="'search.mdm-search.title-search-as-json' | translate" [(visible)]="childJsonDialog">
  <textarea cols="100" rows="15">{{ searchJson }}</textarea>
  <p-footer>
    <p-button
      (onClick)="childJsonDialog = false"
      [title]="'search.mdm-search.button-close' | translate"
      [label]="'search.mdm-search.btn-close' | translate"
    ></p-button>
  </p-footer>
</p-dialog>

<p-dialog
  [header]="'search.mdm-search.title-takeover' | translate"
  [(visible)]="takeOverDialogVisible"
  [breakpoints]="{ '960px': '75vw' }"
  [style]="{ width: '50vw' }"
  [modal]="true"
  [draggable]="false"
  [resizable]="false"
>
  <span *ngIf="!takeOverNameExists">{{ "search.mdm-search.msg-takeover" | translate }}</span>
  <span *ngIf="takeOverNameExists">{{ "search.mdm-search.msg-takeover-name-exists" | translate }}</span>

  <div class="mt-2">
    <input type="text" pInputText [(ngModel)]="takeOverSearchFilter.name" />
  </div>

  <ng-template pTemplate="footer">
    <p-button (click)="takeOver()" [label]="'user-prefs.channel-filter-prefs.btn-save' | translate"></p-button>
    <p-button (click)="takeOverDialogVisible = false" [label]="'user-prefs.channel-filter-prefs.btn-cancel' | translate"></p-button>
  </ng-template>
</p-dialog>
